library arc_dir;

{$Linker DESCRIPTION 'base archiver formats'}
Uses plugdef{$IFDEF WIN32}, windows {$ENDIF} ;
{ ----------------------------------------------------------------------}
const
 defIdent : pchar = 'dir.fmt';
 defSign  : pchar = 'Dir fmt by Chem`O Dun';
var
  FmtAPI  : TPluginStartupInfo;
  isInited : boolean;

{$I strings.inc}
{$I datetime.inc}

{ ---------------------------------- DIR --------------------------------- }
const DirInfo : tFmtAPIArchSetupInfo =
(
 Ident              : nil;
 Sign               : 'DIR';
 Desc               : 'CDDIR (C) 1999 by Igor Grabelnikov';
 Packer             : '';
 UnPacker           : '';
 Extract            : '';
 ExtractWP          : '';
 Add                : '';
 Move               : '';
 Delete             : '';
 Test               : '';
 Password           : '';
 IncludePaths       : '';
 ExcludePaths       : '';
 ForceMode          : '';
 RecoveryRec        : '';
 SelfExtract        : '';
 Solid              : '';
 List               : '';
 Default            : '';
 StoreCompression   : '';
 FastestCompression : '';
 FastCompression    : '';
 NormalCompression  : '';
 GoodCompression    : '';
 UltraCompression   : '';
 ListChar           : '';
 UseLFN             : '';
 PutTempBefore      : 2 ;
 Options            : 0
);

procedure DirInit(AIdent : PChar);
begin
 DirInfo.Ident:=AIdent;
 DirInfo.Options:= cFmtAPIarchIntPack or cFmtAPIarchNoUnp;
end;


type
  DIRHeader = record
    FSize : LongInt;
    DATE  : LongInt;
    Attr  : LongInt;
    FNLen : SmallWord;
   end;

 DirInternal = record
  DirType : Longint;
  DirNext : Longint;
  DirName : PChar;
  DirLen  : SmallWord;
 end;

 Dir2Header  = record
  FileAttr : longint;        // ਡ 䠩/४ਨ
  {$IFDEF WIN32}
  FileDateTime : TFileTime;  //   ६ 䨪樨 䠩/४ਨ
  {$ELSE}
  FileDateTime : comp;
//  FileDate : longint;        //   ६ 䨪樨 䠩/४ਨ
//  FileTime : longint;        //   ६ 䨪樨 䠩/४ਨ
  {$ENDIF}
  FileSize : longint;        // ࠧ 䠩
  NameLen  : smallword;      //   䠩/४ਨ
 end;

const
  H_SIZE = SizeOf(DIRHeader);
  H2_SIZE = SizeOf(DIR2Header);


function DirDetect( ArchStream: Pointer; ArchPos: Longint; ArchName: PChar; var Additional : Pointer):longint;
var
  Head    : Array[0..5] of char;
begin
 FmtAPI.StreamSeek(ArchStream,ArchPos);
 Result:=0;
 FmtAPI.StreamRead(ArchStream,Head, 6);
 if (FmtAPI.StreamGetStat(ArchStream) = cFmtAPIStreamOk) then
  if (Head+#0 ='DIR02 '#0)  then
   begin
    GetMem(Additional,SizeOf(DirInternal));
    DirInternal(Additional^).DirType:=2;
    DirInternal(Additional^).DirName:=nil;
    DirInternal(Additional^).DirNext:=0;
    DirInternal(Additional^).DirLen:=0;
    Result:=1;
   end
  else if (Head+#0 ='CDDIR '#0)  then
   begin
    GetMem(Additional,SizeOf(DirInternal));
    DirInternal(Additional^).DirType:=1;
    DirInternal(Additional^).DirName:=nil;
    DirInternal(Additional^).DirNext:=0;
    DirInternal(Additional^).DirLen:=0;
    Result:=1;
   end;
end;


function DirGetFile( ArchStream: Pointer; ArchFileInfo : pFmtAPIArchFileInfo; Additional : Pointer): longint;
var
  Hdr     : DirHeader;
  Hdr2    : Dir2Header;
  DescLen : smallword;
  i       : byte;
begin
 Result:= 2;
 if (ArchStream <> nil) and (FmtAPI.StreamGetStat(ArchStream) =  cFmtAPIStreamOk ) then
  begin
   if DirInternal(Additional^).DirType = 1 then
    begin
     if FmtAPI.StreamEof(ArchStream) = 0 then
      begin
       FmtAPI.StreamRead(ArchStream, Hdr, H_SIZE);
       GetMem(ArchFileInfo^.FName,Hdr.FNLen+1);
       FmtAPI.StreamRead(ArchStream,ArchFileInfo^.FName[0], Hdr.FNLen);
       ArchFileInfo^.FName[Hdr.FNLen]:=#0;
       Result      := 0;
       ArchFileInfo^.USize     := Hdr.FSize;
       ArchFileInfo^.PSize     := Hdr.FSize;
       ArchFileInfo^.Attr      := Hdr.Attr;
       ArchFileInfo^.Date      := Hdr.Date;
      end
     else
      Result      := 1;
    end
   else if DirInternal(Additional^).DirType = 2 then
    begin
     if (DirInternal(Additional^).DirNext = 0 ) or
        (DirInternal(Additional^).DirNext = FmtAPI.StreamGetPos(ArchStream)) then
      begin
       Result:=FmtAPI.StreamEof(ArchStream);
       if Result <> 0 then
        Exit;
       Result :=2;
       if DirInternal(Additional^).DirLen <> 0 then
        FreeMem(DirInternal(Additional^).DirName,DirInternal(Additional^).DirLen);
       FmtAPI.StreamRead(ArchStream,DirInternal(Additional^).DirLen, 2);
       if FmtAPI.StreamGetStat(ArchStream) <>  cFmtAPIStreamOk then
        Exit;
       if DirInternal(Additional^).DirLen <> 0 then
        begin
         GetMem(DirInternal(Additional^).DirName,DirInternal(Additional^).DirLen);
         FmtAPI.StreamRead(ArchStream,DirInternal(Additional^).DirName[0], DirInternal(Additional^).DirLen);
         if FmtAPI.StreamGetStat(ArchStream) <>  cFmtAPIStreamOk then
          Exit;
        end;
       FmtAPI.StreamRead(ArchStream,DirInternal(Additional^).DirNext, SizeOf(LongInt));
       if FmtAPI.StreamGetStat(ArchStream) <>  cFmtAPIStreamOk then
        Exit;
      end;
     FmtAPI.StreamRead(ArchStream, Hdr2, H2_SIZE);
     if FmtAPI.StreamGetStat(ArchStream) <>  cFmtAPIStreamOk then
      Exit;
     if Hdr2.NameLen = 0 then
      Exit;
     if Hdr2.fileAttr and cFmtAPIDirectory <> 0 then
      i:=1
     else
      i:=0;
     if DirInternal(Additional^).DirLen <> 0 then
      begin
       GetMem(ArchFileInfo^.FName,DirInternal(Additional^).DirLen+Hdr2.NameLen+2+i);
       Move(DirInternal(Additional^).DirName[0], ArchFileInfo^.FName[0],DirInternal(Additional^).DirLen);
       ArchFileInfo^.FName[DirInternal(Additional^).DirLen]:=FmtAPI.SysPathSep;
       FmtAPI.StreamRead(ArchStream, ArchFileInfo^.FName[DirInternal(Additional^).DirLen+1], Hdr2.NameLen);
       if i > 0 then
        ArchFileInfo^.FName[DirInternal(Additional^).DirLen+Hdr2.NameLen+1]:=FmtAPI.SysPathSep;
       ArchFileInfo^.FName[DirInternal(Additional^).DirLen+Hdr2.NameLen+1+i]:=#0;
      end
     else
      begin
       GetMem(ArchFileInfo^.FName,Hdr2.NameLen+1);
       FmtAPI.StreamRead(ArchStream, ArchFileInfo^.FName[0], Hdr2.NameLen);
       if i > 0 then
        ArchFileInfo^.FName[Hdr2.NameLen]:=FmtAPI.SysPathSep;
       ArchFileInfo^.FName[Hdr2.NameLen+i]:=#0;
      end;
     FmtAPI.StreamRead(ArchStream, DescLen, SizeOf(DescLen));
     if DescLen > 0 then
      FmtAPI.StreamSeek(ArchStream,DescLen+FmtAPI.StreamGetPos(ArchStream));
     Result      := 0;
     ArchFileInfo^.USize     := Hdr2.FileSize;
     ArchFileInfo^.PSize     := Hdr2.FileSize;
     ArchFileInfo^.Attr      := Hdr2.fileAttr;
     {$IFDEF WIN32}
     FileTimeToDosDateTime(Hdr2.FileDateTime,TDateTimeRec(ArchFileInfo^.Date).FDate,TDateTimeRec(ArchFileInfo^.Date).FTime)
     {$ELSE}
     ArchFileInfo^.Date      := MSDateTimeToPack(Hdr2.FileDateTime);
     {$ENDIF}
    end;
  end;
end;

function DirClose(var Additional : Pointer): longint;
begin
 if Additional <> nil then
  begin
   if DirInternal(Additional^).DirLen <> 0 then
    FreeMem(DirInternal(Additional^).DirName,DirInternal(Additional^).DirLen);
    FreeMem(Additional,SizeOf(DirInternal));
  end;
 Additional:=nil;
end;

{ ---------------------------------- DIR --------------------------------- }

function SetStartupInfo(var info):longint;
begin
 Result:=0;
 if not isInited then
  Move(info, FmtAPI, SizeOf(FmtAPI));
 DirInit(defIdent);
 if FmtAPI.ArchiveInit(@DirInfo,DirDetect,DirGetFile,DirClose,cFmtAPIarchReplaceAble) = 1 then
  Result:=1;
 isInited:=true;
end;

function GetFMTVersion : PChar;
begin
 Result:=cFMTAPIVersion;
end;

function GetSign : PChar;
begin
 Result:= defSign;
end;


exports
  SetMemoryManager                    name pSetMemoryManager,
  GetFMTVersion                       name pGetFMTVersion,
  GetSign                             name pGetSign      ,
  SetStartupInfo                      name pSetStartupInfo;

initialization
 isInited:=false;
End.
