{$IFDEF VIRTUALPASCAL} {$Use32-} {$ENDIF}
Unit plugdef;

interface

const
  pGetSign         = 'tAPIGetSign';
  pGetFMTVersion   = 'tAPIGetFMTVersion';
  pSetStartupInfo  = 'tAPISetStartupInfo';
  pSetMemoryManager = 'tAPISetMemoryManager';

const
 cFMTAPIVersion : pchar = '0.6.1';

type

 pFmtAPIArchFileInfo = ^tFmtAPIArchFileInfo;
 tFmtAPIArchFileInfo = Record
  FName   : PChar;
  Desc    : PChar;
  USize   : LongInt;
  PSize   : LongInt;
  Date    : LongInt;
  Attr    : Byte;
 end;

type
 pFmtAPIArchSetupInfo = ^tFmtAPIArchSetupInfo;
 tFmtAPIArchSetupInfo = packed record
  Ident,
  Sign,
  Desc,
  Packer,
  UnPacker,
  Extract,
  ExtractWP,
  Add,
  Move,
  Delete,
  Test,
  Password,
  IncludePaths,
  ExcludePaths,
  ForceMode,
  RecoveryRec,
  SelfExtract,
  Solid,
  List,
  Default,
  StoreCompression,
  FastestCompression,
  FastCompression,
  NormalCompression,
  GoodCompression,
  UltraCompression,
  ListChar,
  UseLFN : PChar;
  PutTempBefore : byte;
  Options : longint;
 end;

Const

 cFmtAPIarchInternal       : longint =  $00000001;
 cFmtAPIarchReplaceAble    : longint =  $00000002;
 cFmtAPIarchNoReplaceAble  : longint =  $00000004;
 cFmtAPIarchExtList  : longint =  $00000010;
 cFmtAPIarchIntPack  : longint =  $00000100;
 cFmtAPIarchIntUnp   : longint =  $00000101;
 cFmtAPIarchNoPack   : longint =  $00000102;
 cFmtAPIarchNoUnp    : longint =  $00000104;



{}

type

 tFmtAPIGetString    = function : pchar;

 tFmtAPISetMemoryManager = procedure (const MemMgr: TMemoryManager);

 tFmtAPISetStartupInfo= function(var info) : Integer;

{}

 tFmtAPIDetectArchive = function( ArchStream: Pointer; ArchPos: Longint; ArchName: PChar; var Additional : Pointer):longint;
 tFmtAPIGetNextFile   = function( ArchStream: Pointer; ArchFileInfo : pFmtAPIArchFileInfo; Additional : Pointer): longint;
 tFmtAPICloseArchive  = function( var Additional : Pointer): longint;

 tFmtAPIInitArchive   = function (AArchInfo: pFmtAPIArchSetupInfo; ADetect: tFmtAPIDetectArchive; AGetNextFile : tFmtAPIGetNextFile; AClose : tFmtAPICloseArchive; AMode: longint):longint;



 tFmtAPIStreamOpen          = function (FileName: PChar; Mode: Longint) : Pointer;
 tFmtAPIStreamReadWrite     = function (Stream : Pointer; var B; Size : longint) : longint;
 tFmtAPIStreamReadWriteLn   = function (Stream : Pointer; var S :shortstring): longint;
 tFmtAPIStreamReadWriteChLn = function (Stream : Pointer; var P :Pchar): longint;
 tFmtAPIStreamClose         = function (Stream : Pointer) : Pointer;
 tFmtAPIStreamGetInfo       = function (Stream : Pointer) : Longint;
 tFmtAPIStreamTruncate      = procedure(Stream : Pointer);
 tFmtAPIStreamSeek          = function (Stream : Pointer; Pos: Longint) : Boolean;
 tFmtAPIStreamEof           = function (Stream : Pointer) : longint;
 tFmtAPIStreamSearch        = function (Stream : Pointer; SStr: PChar; Pos: Longint) : LongInt;
 tFmtAPISysPathSep          = function : char;

 tFmtAPIChangeCase          = function (Str: Pchar; Mode : byte):PChar;

Const

  cFmtAPIReadOnly  : longint = $01;
  cFmtAPIHidden    : longint = $02;
  cFmtAPISysFile   : longint = $04;
  cFmtAPIVolumeID  : longint = $08;      // N/A under OS/2
  cFmtAPIDirectory : longint = $10;
  cFmtAPIArchive   : longint = $20;


  cFmtAPIStreamCreate    : longint = $00003C00;           { Create new file }
  cFmtAPIStreamOpenRead  : longint = $00003D40;           { Read access only }
  cFmtAPIStreamOpenWrite : longint = $00003D41;           { Write access only }
  cFmtAPIStreamOpen      : longint = $00003D42;           { Read and write access }

  cFmtAPIStreamOk        : longint =  0;              { No error }
  cFmtAPIStreamError     : longint = -1;              { Access error }
  cFmtAPIStreamInitError : longint = -2;              { Cannot initialize stream }
  cFmtAPIStreamReadError : longint = -3;              { Read beyond end of stream }
  cFmtAPIStreamWriteError: longint = -4;              { Cannot expand stream }
  cFmtAPIStreamGetError  : longint = -5;              { Get of unregistered object type }
  cFmtAPIStreamPutError  : longint = -6;              { Put of unregistered object type }

  cFmtAPIUpCase          : byte    = 0;
  cFmtAPILowCase         : byte    = 1;
{}

type
 pPluginStartupInfo = ^tPluginStartupInfo;
 tPluginStartupInfo = packed record
  StructSize      : Integer;
  SysPathSep      : tFmtAPISysPathSep;
  StreamOpen      : tFmtAPIStreamOpen;
  StreamRead      : tFmtAPIStreamReadWrite;
  StreamWrite     : tFmtAPIStreamReadWrite;
  StreamReadLn    : tFmtAPIStreamReadWriteLn;
  StreamWriteLn   : tFmtAPIStreamReadWriteLn;
  StreamReadChLn  : tFmtAPIStreamReadWriteChLn;
  StreamWriteChLn : tFmtAPIStreamReadWriteChLn;
  StreamClose     : tFmtAPIStreamClose;
  StreamGetStat   : tFmtAPIStreamGetInfo;
  StreamGetSize   : tFmtAPIStreamGetInfo;
  StreamGetPos    : tFmtAPIStreamGetInfo;
  StreamTruncate  : tFmtAPIStreamTruncate;
  StreamSeek      : tFmtAPIStreamSeek;
  StreamEof       : tFmtAPIStreamEof;
  StreamSearch    : tFmtAPIStreamSearch;
  ArchiveInit     : tFmtAPIInitArchive;
  ChangeCase      : tFmtAPIChangeCase;
 end;

implementation

end.
